import java.math.*;

/**
 * <p> Autor Michael Gorski </p>
 * <p> Version 1.0 </p>
 * <p>Copyright: Copyright (c) 2004 </p>
 */

/** Klasse fr mathematische Hilfsfunktion.*/
public class MathFunction
{
	final static BigInteger zero = new BigInteger("0");
	final static BigInteger one = new BigInteger("1");
	final static BigInteger two = new BigInteger("2");
	final static BigInteger three = new BigInteger("3");
	final static BigInteger four = new BigInteger("4");
	final static BigInteger five = new BigInteger("5");
	final static BigInteger six = new BigInteger("6");
	final static BigInteger seven = new BigInteger("7");
	final static BigInteger eight = new BigInteger("8");

	/** Variable, um die Ausgaben der print Funktion ein und ausschalten zu knnen. */
	public static boolean canPrint = true;

//=====================================================================================================

	/** Liefert eine zufllige ungerade Zahl kleiner als p zurck. */
	public static BigInteger getRandomNumberOdd(BigInteger p)
	{
		BigInteger x = new BigInteger("0");
		BigInteger q = new BigInteger("0");
		BigInteger test = new BigInteger("0");
		boolean found = false;
		while (!found)
		{
			x = getRandomNumber(p);
			q = getRandomNumber(p);
			test = x.add(q);
			test = test.mod(new BigInteger("2"));
			if (test.compareTo(new BigInteger("1")) == 0)	// test ob x ungerade
				found = true;
		}
		return(x);
	} //end getRandomNumberOdd

//=====================================================================================================

	/** Liefert eine zufllige Zahl kleiner als p zurck. */
	public static BigInteger getRandomNumber(BigInteger p)
	{
		int i;
		double d = Math.random()*1000000;
		double d2 = Math.random()*1000000;
		i = (new Double(d)).intValue();
		BigInteger x = new BigInteger(""+i);
		i = (new Double(d2)).intValue();
		BigInteger x2 = new BigInteger(""+i);
	    while (x.compareTo(p) == -1) 					// (x < p)
		{
			x = x.multiply(x2);
		}
		x = x.mod(p);
		return(x);
	} // end getRandomNumber

//=====================================================================================================

	/** Liefert den Wert des Legendre - Symbols von (a/p). */
	public static int getLegendre(BigInteger a, BigInteger p)
	{
		if( (a.mod(p)).compareTo(zero) == 0)							// wenn a = 0 mod p
			return(0);
		else
		{
			BigInteger e = (p.subtract(one)).divide(two);						// e = (p-1)/2
			BigInteger legendre = a.modPow(e,p);						// a^e mod p

			if( (legendre).compareTo(one) == 0)
				return(1);
			else
				return(-1);
		}
	} // end getLegendre

//=====================================================================================================

	/** Liefert die Quadratwurzel von a modulo p. */
	public static BigInteger getSqrt(BigInteger a, BigInteger p)
	{
		MathFunction.print(" Quadratwurzel mod p finden ");
		BigInteger k = zero;
		BigInteger x = zero;
		BigInteger e = zero;
		BigInteger q = zero;
		BigInteger left = zero;
		BigInteger right = zero;
		BigInteger n = zero;
		BigInteger test = zero;
		BigInteger test1 = zero;
		BigInteger test2 = zero;
		BigInteger y = zero;
		BigInteger r = zero;
		BigInteger b = zero;
		BigInteger t = zero;
		BigInteger m = zero;
		BigInteger texp = zero;

        // da es in Schritt 6 bei texp auch Werte geben kann die nicht invertierbar sind, muss
        // dieser Fall abgefangen werden
		try{

//SCHRITT 1:
		if( (p.mod(four)).compareTo(three) == 0 )			//wenn p = 3 mod 4
		{
			k = (p.subtract(three)).divide(four);			// k = (p-3)/4
			x = a.modPow( (k.add(one)) ,p);					// x = a^(k+1) mod p
			return(x);
		}  // end if
//SCHRITT 2:
        // nichtquadratischen Rest n bestimmen
		do
		{
			n = getRandomNumber(p);
		} while ( !(getLegendre(n,p) == -1) );
		MathFunction.print("[getSqrt]: Legendre(n,p) = -1 gefunden");

//SCHRITT 3:
		left = p.subtract(one);								// linkeSeite = p-1

//SCHRITT 4: e und q bestimmen mit p-1 = 2^e q und q ungerade
        boolean found = false;
		do
		{
			e = e.add(one);
			q = left.divide(two);							// q = left/2
			test1 = left.mod(two);
			test2 = q.mod(two);
			left = q;
			if (( test1.compareTo(zero) == 0  )&&			// wenn  left durch 2 teilbar ist.
			    ( test2.compareTo(one) == 0  ))				// und test2 (q) ungerade
				found = true;
		} while( !found );
        MathFunction.print("[getSqrt]: e,q gefunden");

//SCHRITT 5:
		y = n.modPow(q,p);
		r = e;
		x = a.modPow( (q.subtract(one)).divide(two)  ,p);
		b = ( (x.modPow(two,p)).multiply(a) ).mod(p);
		x = ( a.multiply(x) ).mod(p);

//SCHRITT 6:
		while ( !(b.compareTo(one) == 0) )
		{
			//test = b;
			m = zero;
			do
			{
				m = m.add(one);
 				//test = test.modPow(two,p);
 				test1 = two.multiply(m);
 				test = b.modPow(test1,p);
			} while ( !(test.compareTo(one) == 0) );

			texp = two.modPow( ((r.subtract(m)).subtract(one)),p.subtract(one));  //#  berprfen p-1 ???

			t = y.modPow(texp,p);
			y = t.modPow(two,p);
			r = m;
			x = ( x.multiply(t) ).mod(p);
			b = ( b.multiply(y) ).mod(p);
		} //end while
//SCHRITT 7:
		MathFunction.print("[getSqrt]: Quadratwurzel von a modulo p gefunden");

		} catch(Exception e1) { x = getSqrt(a, p); }

		return(x);
	} // end getSqrt

//=====================================================================================================

	/** Liefert die n-te Einheitswurzel von y mittels Newton Verfahren zurck. */
	public static BigDecimal nSqrt(int n, BigInteger a)
	{
		BigDecimal d_a = new BigDecimal(a);
        BigDecimal d_n = new BigDecimal(n);
		BigDecimal x0 = new BigDecimal("0");
		BigDecimal x1 = new BigDecimal("0");
		BigDecimal f_x = new BigDecimal("0");
		BigDecimal ff_x = new BigDecimal("0");
 		String s_old = "";
 		String s = "";
        x0 = new BigDecimal("4.0");

 		//x[i+1] = x[i] - f(x[i])/f'(x[i])

        for(int i= 0; i < 9000; i++)
        {
			f_x = (x0.pow(n)).subtract(d_a);
		    ff_x = (x0.pow(n-1)).multiply(d_n);
            x1 = x0.subtract( f_x.divide(ff_x,BigDecimal.ROUND_UP) );
            s = x1.toString();
            if (s.length() >= 5)
            	s = s.substring(0,5);
            else if (s.length() < 3)
            	s = s.substring(0,s.length() );

            if( s_old.compareTo(s) == 0)
             	return(x1);

            s_old = s;
            x1 = new BigDecimal(s);
            x0 = x1;
	    }
		return(x1);
	} // end nSqrt

//=====================================================================================================

	/** Rundet eine gebrochene Zahl auf die nchste ganze Zahl auf und liefert diese zurck.
	Es erfolgt dabei eine Typkonvertierung von BigDecimal auf BigInteger. */
	public static BigInteger ceil(BigDecimal n)
	{
		BigInteger i = new BigInteger("0");
		n = n.add(new BigDecimal(one));
		i = n.toBigInteger();
		return(i);
	} // end ceil

//=====================================================================================================

	/** Rundet eine gebrochene Zahl auf die nchste ganze Zahl ab und liefert diese zurck.
	Es erfolgt dabei eine Typkonvertierung von BigDecimal auf BigInteger. */
	public static BigInteger floor(BigDecimal n)
	{
		BigInteger i = new BigInteger("0");
		i = n.toBigInteger();
		return(i);
	} // end floor

//=====================================================================================================

	/** Erzeugt eine Konsolenausgabe wie System.out.println, diese kann aber durch die Variable
	canPrint ein und ausgeschaltet werden. */
	public static void print(String s)
	{
		if(canPrint)
			System.out.println(s);
	} // end print

//=====================================================================================================

	/** Berechnet die Lsung eines Kongruenzsystems mit dem Chinesischen Restsatz.
	Von einem Kongruenzsystems der Form x = x_i mod l werden die x_i Werte durch das
	BigIntegerArray r bergeben. Die Anzahl der Gleichungen wird durch numberOfPrimes festgelegt.
	Mit m wird das Produkt der Primzahlen bergeben. Die Funktion geht davon aus, dass in dem System
	die Werte fr l die ersten numberOfPrimes Primzahlen sind.
	*/
 	public static BigInteger getCRS(BigIntegerArray r, BigInteger numberOfPrimes, BigInteger m)
 	{
		print("");
		print("numberOfPrimes: "+numberOfPrimes);
		print("Produkt der Primzahlen: "+m);

		BigInteger mi = zero;
		BigInteger [] uv;
		BigInteger q = zero;
		BigInteger x = zero;
		for(BigInteger i = zero; i.compareTo(numberOfPrimes) == -1; i = i.add(one))
		{
			q = q.nextProbablePrime();
			mi = m.divide(q);
			uv = getGCDEX(mi,q);
			print("t_l = "+ r.get(i) +" mod " + q);
			x = x.add(  ( (uv[0]).multiply(mi) ).multiply(r.get(i))  );
		}
		print("");
		return(x);
	} // end getCRS

//=====================================================================================================

	/** Berechnet den erweiterten Euklidischen Algorithmus von zwei ganzen Zahlen vom Typ BigInteger. */
 	public static BigInteger [] getGCDEX(BigInteger a, BigInteger b)
 	{
		BigInteger [] uv = new BigInteger [2];
		uv[0] = one;
		BigInteger d = a;
		BigInteger v1,v3,q,t1,t3;
		BigDecimal temp1, temp2;

		if ( b.compareTo(zero) == 0 )
		{
			uv[1] = zero;
			return(uv);
		}
		else
		{
			v1 = zero;
			v3 = b;
		}

		while(true)
		{
			if ( v3.compareTo(zero) == 0 )
			{
				uv[1] = (d.subtract(a.multiply(uv[0])) ).divide(b);
				return(uv);
			}
		    temp1 = new BigDecimal(d);
		    temp2 = new BigDecimal(v3);

			temp1 = temp1.divide(temp2,BigDecimal.ROUND_DOWN);

			q = floor(temp1);
			t3 = d.mod(v3);
			t1 = uv[0].subtract(q.multiply(v1));
			uv[0] = v1;
			d = v3;
			v1 = t1;
			v3 = t3;
		} // end while
	} // end getGCDEX

//=====================================================================================================
} //MathFunction