import java.math.*;

/**
 * <p> Autor Michael Gorski </p>
 * <p> Version 1.0 </p>
 * <p>Copyright: Copyright (c) 2004 </p>
 */

/** Klasse, um projektive Punkte einer elliptischen Kurve darstellen zu knnen. */
public class ProjectivePoint
{
	BigInteger x;
	BigInteger y;
	BigInteger z;

//======================================================================================================

    /** Konstruktor fr den Punkt im Unendlichen O. */
	public ProjectivePoint()
	{
		this.x = new BigInteger("1");
		this.y = new BigInteger("1");
		this.z = new BigInteger("0");
	}

//======================================================================================================

    /** Konstruktor fr projektive Koordinaten vom Typ BigInteger. */
	public ProjectivePoint(BigInteger x, BigInteger y, BigInteger z)
	{
		this.x = x;
		this.y = y;
		this.z = z;
	}

//======================================================================================================

    /** Konstruktor fr projektive Koordinaten vom Typ String. */
	public ProjectivePoint(String x, String y, String z)
	{
		this.x = new BigInteger(x);
		this.y = new BigInteger(y);
		this.z = new BigInteger(z);
	}

//======================================================================================================

    /** Konstruktor fr affine Koordinaten vom Typ BigInteger. */
	public ProjectivePoint(BigInteger x, BigInteger y)
	{
		this.x = x;
		this.y = y;
		this.z = new BigInteger("1");
	}

//======================================================================================================

   	/** Konstruktor fr affine Koordinaten vom Typ String. */
	public ProjectivePoint(String x, String y)
	{
		this.x = new BigInteger(x);
		this.y = new BigInteger(y);
		this.z = new BigInteger("1");
	}

//======================================================================================================

	/** Setzt die x Koordinate des projektiven Punktes. */
	public void setX(BigInteger x)
	{
		this.x = x;
	}

//======================================================================================================

	/** Setzt die y Koordinate des projektiven Punktes. */
	public void setY(BigInteger y)
	{
		this.y = y;
	}

//======================================================================================================

	/** Setzt die z Koordinate des projektiven Punktes. */
	public void setZ(BigInteger z)
	{
		this.z = z;
	}

//======================================================================================================

	/** Liefert den Wert der x Koordinate des projektiven Punktes zurck. */
	public BigInteger getX()
	{
		return(x);
	}

//======================================================================================================

	/** Liefert den Wert der y Koordinate des projektiven Punktes zurck. */
	public BigInteger getY()
	{
		return(y);
	}

//======================================================================================================

	/** Liefert den Wert der z Koordinate des projektiven Punktes zurck. */
	public BigInteger getZ()
	{
		return(z);
	}

//======================================================================================================

	/** Gibt den projektiven Punkt als String zurck. */
	public String toString()
	{
		if( z.compareTo(new BigInteger("0")) == 0 )
			return("(0,1,0)");
	    else
			return("("+x.toString()+","+y.toString()+","+z.toString()+")");
	}

//======================================================================================================
} //end ProjectivePoint